package com.ashokit.helloworld;

import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;

@SpringBootApplication

/*
 * 
 * 
 * 
 *  Any Java Class which is having an annotation @SpringBootApplication called as bootstrap class
 *  Bootstrap ==> Starting Point of Execution
 *  
 *  Every Project Should have only one bootstrap Class
 *  
 *  Functionality of Bootstrap Class
 *  		1) This will create an IOC Container ==> Inversion of Control Container 
 *                                               ==> Efficient Memory managment 
 *                                                     ==> Creating the object,Managing the State of Object,Destoying Object
 *           								     ==> This is a seperate Memory Area managed by Spring not by Garbage Collector
 *           
 *           2) Enable Auto Scan                ==>  It Automatically Scans the Class path and identifying the interfaces 
 *                                                    which are eligible to start during startup
 *                                                        a) Database Connection
 *                                                        b) Starting Tomcat
 *                                                        c) WebApplication Context
 *                                                        d) DispatcherServlet
 *                                                        e) FrontController
 *                                                        
 *           3) WebApplicationContext		    ==>  Identifying the Eligible Classes in the project and initializing them
 *                                                    during startup==> Creating object for all eligigle classes
 *                                                    
 *                                                    
 *                                                    <bean id="employee" class="com.ashokit.Employee" scope="singleton">
 *                                                    <cont: componentscan "com.ashokit.employee.*" />
 *                                                    
 *                                                    
 *                                                    EmployyController,EmployeService,EmployeeDao
 *                                                    
 *                                                    EmployeeController obj;
 *                                                    EmployeeService obj1;
 *                                                    EmployeeDao obj2;
 *                                                    
 *                                                    
 *                                                    
 *                                                    
 *  
 */
public class HelloWorldExample {

	public static void main(String[] args) {
		
		SpringApplication.run(HelloWorldExample.class, args);
		
		/*
		 * 
		 * It will scan all the Java Files under Bootstrap class package and Bootstrap class subpackage and pushes to IOC
		 * 
		 * com.amazon.ordering ==> BoostraClass
		 * com.amazon.ordering.Customer ==> All Customer Relations In this pacakge
		 * com.amazon.ordering.Product  ==> All Product Functionalities
		 * com.amazon.ordering.Inventory  ==> All Inventory Functionalities
		 * com.amazon.ordering.Cart  ==> All Cart Functionalities
		 * com.amazon.ordering.Payment  ==> All Payment Functionalities
		 * com.amazon.ordering.Discount  ==> All Discount Functionalities
		 * 
		 * 
		 * com.other.ordering.Return ==> This will be skipped and not available in IOC
		 * 
		 * 
		 * WebApplicationContext context=new XMLWeBapplicationContext(spring.xml);
		 * 
		 */

	}

}
