package com.ashokit.example;

import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;

@SpringBootApplication

/*
 * A Java File with @SpringBootApplication is called as Bootstrap Class
 * 
 * Bootstrap is starting point of execution on the spring boot project
 * 
 * Every Spring boot project should have only one bootstrap class
 * 
 * BootStrap Class Responsibilities:
 * 1) At runtime  this will create IOC Container Inversion Of Control Container 
 * 
 * IOC ==> Object Managment==> Creating,Managing the State and Destroying the Object
 * 
 * Developer no need to write any code for object managment
 * 
 * Depdency Injection ==> Spring creates object not only for parent class , first it will creates for child classes
 *                         And then it assigns to Parent Class , On Destryoing of parent class , All Objects will be garbaged
 *                         
 *                         
 * 2) It has a feature of EnableAutoScan ==> It automatically scans all the java files at run time, and starts which are 
 *                                  enabled with autostart like Tomcat Startup, DB Connection etc.
 *                                  
 * 3) This will create Web Application Context ==> A seperate Memory Area in IOC which contains the objects of active classes
 *                                    Active Class ==> Current Functional Feature accessed by customer 
 *                                    
 *      At run time all the object are created but not initiliazed and object initilization will happen 
 *                only during Web application Context
 *                
 *                
 *                
 *                In a project we wrote 5 classes , Product,Customer,Cart,Payment,Discount,Shipment
 *                
 *           Product prod=ioc.getProduct()  , Customer cust=ioc.getCustomer(), Cart cart=ioc.getCart() 
 *           Payment pay=ioc.getPayment()    Discount dis=ioc.getDiscount()  Shipment ship=ioc.getShipment()
 *           
 *           
 *          prd.getproducts();==> Memroy will be allocate during web application context  
 *          
 *                       
 *                       
 *                       
 *           OrderService ordService=null;  Object is Created
 *           
 *           ordService=new OrderService() ==> Memory is initialized for ordService;
 *           
 *             ordService.processOrder() ==> once the role is over ==> ordService=null is taken care by IOC
 *             
 *             ordService will be destoryed when we stop the application
 *           
 *           
 *           
 *  
 * 
 * 
 */
public class HelloWorldStsApplication {

	public static void main(String[] args) {
		/*
		 *The below line will scan all the java classes available in bootstrap package and bootstrap sub package
		 *
		 * and load the classes for setting up of webapplication context
		 *
		 * It will identify all the java classes in bootstrap package and bootstrap sub package
		 * 
		 * com.amazon.orderprocessing ==> Boostrap package ==> Main Package
		 * 
		 * com.amazon.orderprocessing.Customer ==> Customer Functionality Code
		 * com.amazon.orderprocessing.Prodcut  ==> Product Functionaity code
		 * com.amazon.orderprocessing.Inventory ==> INventory related code
		 * com.amazon.orderprocessing.Payment ==> Payment Related Code
		 * com.amazon.orderprocessing.Cart ==> Cart Related code
		 * com.amazon.orderprocessing.shipment ==> Shipment Relatd code
		 * 
		 * com.amazon.other.Other ==> This will not be loaded by IOC and not availble for using this functionality
		 * 
		 *
		 * 
		 */
		SpringApplication.run(HelloWorldStsApplication.class, args);
	}

}
